CON
        _clkmode = xtal1 + pll16x
        _xinfreq = 5_000_000

MHZ = 80
MG     = 1000.0
PIE    = 3.1416

OBJ
FF32      :"Float32Full"
GyroAcc  : "ITG 3200 Sport pasm"
Debug    : "Extended_FDSerial"

VAR
  Long Stack[30]
  Long Roll, Pitch
  Long AxRaw, AyRaw, AzRaw 
  Long Ax, Ay, Az
  Long DBG_Out[20]
  
PUB Main
  FF32.Start                    'Starts Math Engine FF32
  GyroAcc.Start(6,7)            'Starts Gyro
  cognew(Debugger, @Stack[0])   'Starts Debugger Function in new Cog
  waitcnt(clkfreq*4+cnt)        'Waits 4 seconds to let things initialize.
  Dira[5] := 1                  'Scope Pin for Timing
  Outa[5] := 0                  'Set Scope Pin Low
  

Repeat
 '''''''This Section solves the following equation for ACC X and Y axis in Degrees'''''''
       'pitch = atan2(accYval, accZval)+PI    and  roll = atan2(accXval, accZval)+PI
    AxRaw := GyroAcc.GetAx
    AyRaw := GyroAcc.GetAY
    AzRaw := GyroAcc.GetAz

    Ax    := AxRaw * 4          'The ADXL345 has a resolution of 4mG/LSB
    Ax    := FF32.FFloat(Ax)
    Ax    := FF32.FDiv(Ax, MG)  'MG is = 1000 because the 4 above should really be .004mG

    Ay    := AyRaw * 4
    Ay    := FF32.FFloat(Ay)
    Ay    := FF32.FDiv(Ay, MG)

    Az    := AzRaw * 4
    Az    := FF32.FFloat(Az)
    Az    := FF32.FDiv(Az, MG)

    Pitch := FF32.ATan2(Ay, Az)
    Pitch := FF32.FAdd(Pitch, PIE)

    Pitch := FF32.Degrees(Pitch)

    Roll  := FF32.ATan2(Ax, Az)
    Roll  := FF32.FAdd(Roll, PIE)

    Roll := FF32.Degrees(Roll)

    DBG_Out[0] := Roll
    DBG_Out[1] := Pitch
''''''''Debugger is Simply my way of Reading the Floating Point Values on my PC""""""""
PUB Debugger | x , idx
  Debug.start(1,2,0,115200)
  Debug.rxflush
  Dira[3] := 1
  Outa[3] := 0
  repeat    
    x:=Debug.rxtime(100)       
    if x=="a"
      repeat   idx from 0 to 7          ' 3 was 79
        Outa[3] := 1
        Debug.tx(byte[@DBG_Out+idx])
        Outa[3] := 0
      x:=-1    